Index: /trunk/IPs/systemC/processor/Morpheo/TopLevel/doc/Makefile
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/TopLevel/doc/Makefile	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/TopLevel/doc/Makefile	(revision 88)
@@ -0,0 +1,19 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+
+#-----[ Directory ]----------------------------------------
+DIR_COMPONENT			= ../
+include				$(DIR_COMPONENT)/Makefile.defs
+
+#-----[ include ]------------------------------------------
+
+all				:
+				$(MAKE) all_documentation
+
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Common
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Documentation
Index: /trunk/IPs/systemC/processor/Morpheo/TopLevel/include/Morpheo.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/TopLevel/include/Morpheo.h	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/TopLevel/include/Morpheo.h	(revision 88)
@@ -0,0 +1,193 @@
+#ifndef morpheo_Morpheo_h
+#define morpheo_Morpheo_h
+
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#ifdef SYSTEMC
+#include "systemc.h"
+#endif
+
+#include "Behavioural/Core/include/Core.h"
+#include "Behavioural/Custom/include/Custom.h"
+#include "Behavioural/Core/include/Parameters.h"
+#include "Behavioural/Configuration/include/Configuration.h"
+
+#include "TopLevel/include/Types.h"
+
+#ifdef STATISTICS
+#include "Behavioural/include/Stat.h"
+#endif
+#include "Behavioural/include/Component.h"
+#ifdef VHDL
+#include "Behavioural/include/Vhdl.h"
+#endif
+#include "Behavioural/include/Usage.h"
+
+#include "Common/include/ToString.h"
+#include "Common/include/Debug.h"
+
+
+#include <iostream>
+
+namespace morpheo {
+
+  class Morpheo 
+#if SYSTEMC
+    : public sc_module
+#endif
+  {
+    // -----[ fields ]----------------------------------------------------
+    // Parameters
+  private   : std::string                                          _name;
+  private   : behavioural::Tusage_t                                _usage;
+  private   : morpheo::behavioural::configuration::Configuration * _config;
+  private   : morpheo::behavioural::core::Parameters             * _param_core;
+#ifdef STATISTICS
+  private   : morpheo::behavioural::Parameters_Statistics        * _param_statistics;
+  private   : behavioural::Stat                                  * _stat;
+#endif
+
+  private   : behavioural::Component                             * _component;
+  private   : behavioural::Interfaces                            * _interfaces;
+
+    // -----[ interface parameters ]--------------------------------------
+  public    : uint32_t                                             _nb_thread                 ;
+
+  public    : uint32_t                                             _nb_icache_port            ;
+  public    : uint32_t                                             _size_icache_thread_id     ;
+  public    : uint32_t                                             _size_icache_packet_id     ;
+  public    : uint32_t                                             _size_icache_address       ;
+  public    : uint32_t                                             _size_icache_type          ;
+  public    : uint32_t                                             _size_icache_error         ;
+  public    : uint32_t                                           * _icache_nb_instruction     ;//[nb_icache_port]
+  public    : uint32_t                                             _size_icache_instruction   ;
+
+  public    : uint32_t                                             _nb_dcache_port            ;
+  public    : uint32_t                                             _size_dcache_thread_id     ;
+  public    : uint32_t                                             _size_dcache_packet_id     ;
+  public    : uint32_t                                             _size_dcache_address       ;
+  public    : uint32_t                                             _size_dcache_data          ;
+  public    : uint32_t                                             _size_dcache_type          ;
+  public    : uint32_t                                             _size_dcache_error         ;
+  
+  public    : bool                                                 _have_port_icache_thread_id;
+  public    : bool                                                 _have_port_icache_packet_id;
+  public    : bool                                                 _have_port_dcache_thread_id;
+  public    : bool                                                 _have_port_dcache_packet_id;
+
+#ifdef SYSTEMC
+    // ~~~~~[ Interface ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+    // ~~~~~[ Interface : "" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+  public    : SC_CLOCK                         *  in_CLOCK        ;
+  public    : SC_IN (Tcontrol_t)               *  in_NRESET       ;
+
+    // ~~~~~[ Interface "icache_req" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+  public    : SC_OUT(Tcontrol_t           )   ** out_ICACHE_REQ_VAL         ;//[nb_icache_port]
+  public    : SC_IN (Tcontrol_t           )   **  in_ICACHE_REQ_ACK         ;//[nb_icache_port]
+  public    : SC_OUT(Ticache_context_t    )   ** out_ICACHE_REQ_THREAD_ID   ;//[nb_icache_port]
+  public    : SC_OUT(Ticache_packet_t     )   ** out_ICACHE_REQ_PACKET_ID   ;//[nb_icache_port]
+  public    : SC_OUT(Ticache_address_t    )   ** out_ICACHE_REQ_ADDRESS     ;//[nb_icache_port]
+  public    : SC_OUT(Ticache_type_t       )   ** out_ICACHE_REQ_TYPE        ;//[nb_icache_port]
+
+    // ~~~~~[ Interface "icache_rsp" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~  
+  public    : SC_IN (Tcontrol_t           )   **  in_ICACHE_RSP_VAL         ;//[nb_icache_port]
+  public    : SC_OUT(Tcontrol_t           )   ** out_ICACHE_RSP_ACK         ;//[nb_icache_port]
+  public    : SC_IN (Ticache_context_t    )   **  in_ICACHE_RSP_THREAD_ID   ;//[nb_icache_port]
+  public    : SC_IN (Ticache_packet_t     )   **  in_ICACHE_RSP_PACKET_ID   ;//[nb_icache_port]
+  public    : SC_IN (Ticache_instruction_t)  ***  in_ICACHE_RSP_INSTRUCTION ;//[nb_icache_port][icache_nb_instruction]
+  public    : SC_IN (Ticache_error_t      )   **  in_ICACHE_RSP_ERROR       ;//[nb_icache_port]
+
+    // ~~~~~[ Interface "dcache_req" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+  public    : SC_OUT(Tcontrol_t           )   ** out_DCACHE_REQ_VAL         ;//[nb_dcache_port]
+  public    : SC_IN (Tcontrol_t           )   **  in_DCACHE_REQ_ACK         ;//[nb_dcache_port]
+  public    : SC_OUT(Tdcache_context_t    )   ** out_DCACHE_REQ_THREAD_ID   ;//[nb_dcache_port]
+  public    : SC_OUT(Tdcache_packet_t     )   ** out_DCACHE_REQ_PACKET_ID   ;//[nb_dcache_port]
+  public    : SC_OUT(Tdcache_address_t    )   ** out_DCACHE_REQ_ADDRESS     ;//[nb_dcache_port]
+  public    : SC_OUT(Tdcache_data_t       )   ** out_DCACHE_REQ_WDATA       ;//[nb_dcache_port]
+  public    : SC_OUT(Tdcache_type_t       )   ** out_DCACHE_REQ_TYPE        ;//[nb_dcache_port]
+									    
+    // ~~~~~[ Interface "dcache_rsp" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~  
+  public    : SC_IN (Tcontrol_t           )   **  in_DCACHE_RSP_VAL         ;//[nb_dcache_port]
+  public    : SC_OUT(Tcontrol_t           )   ** out_DCACHE_RSP_ACK         ;//[nb_dcache_port]
+  public    : SC_IN (Tdcache_context_t    )   **  in_DCACHE_RSP_THREAD_ID   ;//[nb_dcache_port]
+  public    : SC_IN (Tdcache_packet_t     )   **  in_DCACHE_RSP_PACKET_ID   ;//[nb_dcache_port]
+  public    : SC_IN (Tdcache_data_t       )   **  in_DCACHE_RSP_RDATA       ;//[nb_dcache_port]
+  public    : SC_IN (Tdcache_error_t      )   **  in_DCACHE_RSP_ERROR       ;//[nb_dcache_port]
+
+    // ~~~~~[ Interface : "interrupt" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+  public    : SC_IN (Tcontrol_t           )   **  in_INTERRUPT_ENABLE       ;//[nb_thread] - Interrupt Exception
+
+    // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
+  private   : morpheo::behavioural::core::Core * _component_core            ;
+    
+    // ~~~~~[ Register ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
+
+    // ~~~~~[ Internal ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+#endif
+
+    // -----[ Methods ]---------------------------------------------------
+
+#ifdef SYSTEMC
+    SC_HAS_PROCESS (Morpheo);
+#endif
+  public  :          Morpheo              
+  (
+#ifdef SYSTEMC
+   sc_module_name name,
+#else		  
+   std::string    name,
+#endif		               
+   std::string    filename_simulator,
+   std::string    filename_generator, 
+   std::string    filename_instance ,
+   morpheo::behavioural::custom::custom_information_t (*get_custom_information) (void)
+   );
+  public  :            ~Morpheo                   (void);
+
+  private : std::string header                    (void);
+
+  private : void        configuration             (std::string filename_simulator, 
+                                                   std::string filename_generator, 
+                                                   std::string filename_instance ,
+                                                   morpheo::behavioural::custom::custom_information_t (*get_custom_information) (void));
+					       
+  private : void        allocation                (
+#ifdef STATISTICS
+						   morpheo::behavioural::Parameters_Statistics * param_statistics
+#else
+						   void
+#endif
+						   );
+  private : void        deallocation              (void);
+					       
+#ifdef SYSTEMC				       
+# if defined(STATISTICS) or defined(VHDL_TESTBENCH)
+  private : void        transition                (void);
+# endif					       
+#endif					       
+
+#if VHDL				       
+  private : void        vhdl                      (void);
+#endif					       
+
+#ifdef STATISTICS
+  private : void        statistics_allocation     (morpheo::behavioural::Parameters_Statistics * param_statistics);
+  private : void        statistics_deallocation   (void);
+#endif
+#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
+  private : void        end_cycle                 (void);
+#endif
+
+#ifdef SYSTEMC
+  public  : bool        simulation_end            (void);
+#endif
+  };
+
+}; // end namespace morpheo
+
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/TopLevel/include/Types.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/TopLevel/include/Types.h	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/TopLevel/include/Types.h	(revision 88)
@@ -0,0 +1,34 @@
+#ifndef morpheo_Types_h
+#define morpheo_Types_h
+
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/Types.h"
+
+namespace morpheo {
+
+  // typedef (change namespace)
+  typedef behavioural::Tcontrol_t            Tcontrol_t           ;
+
+  typedef behavioural::Tcontext_t            Ticache_context_t    ;
+  typedef behavioural::Tpacket_t             Ticache_packet_t     ;
+  typedef behavioural::Ticache_address_t     Ticache_address_t    ;
+  typedef behavioural::Ticache_instruction_t Ticache_instruction_t;
+  typedef behavioural::Ticache_type_t        Ticache_type_t       ;
+  typedef behavioural::Ticache_error_t       Ticache_error_t      ;
+  typedef behavioural::Tcontext_t            Ticache_context_t    ;
+
+  typedef behavioural::Tcontext_t            Tdcache_context_t    ;
+  typedef behavioural::Tpacket_t             Tdcache_packet_t     ;
+  typedef behavioural::Tdcache_address_t     Tdcache_address_t    ;
+  typedef behavioural::Tdcache_data_t        Tdcache_data_t       ;
+  typedef behavioural::Tdcache_type_t        Tdcache_type_t       ;
+  typedef behavioural::Tdcache_error_t       Tdcache_error_t      ;
+
+};
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/TopLevel/src/Morpheo.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/TopLevel/src/Morpheo.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/TopLevel/src/Morpheo.cpp	(revision 88)
@@ -0,0 +1,110 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "TopLevel/include/Morpheo.h"
+#include "Common/include/Translation.h"
+
+namespace morpheo {
+
+  using namespace behavioural;
+
+#undef  FUNCTION
+#define FUNCTION "Morpheo::Morpheo"
+  Morpheo::Morpheo 
+  (
+#ifdef SYSTEMC
+   sc_module_name name,
+#else		  
+   std::string    name,
+#endif		               
+   std::string    filename_simulator, 
+   std::string    filename_generator, 
+   std::string    filename_instance ,
+   morpheo::behavioural::custom::custom_information_t (*get_custom_information) (void)
+   )
+  {
+    translation ();
+    
+    log_begin(Morpheo,FUNCTION);
+
+    log_printf(INFO,Morpheo,FUNCTION,_("Configuration"));
+    configuration (filename_simulator,
+                   filename_generator, 
+                   filename_instance, 
+                   get_custom_information);
+ 
+    if (usage_is_set(_usage,USE_HEADER))
+      std::cout << header();
+ 
+    log_printf(INFO,Morpheo,FUNCTION,_("<%s> : Allocation"),_name.c_str());
+
+    allocation (
+#ifdef STATISTICS
+		_param_statistics
+#endif
+		);
+
+#ifdef STATISTICS
+    if (usage_is_set(_usage,USE_STATISTICS))
+      {	
+	log_printf(INFO,Morpheo,FUNCTION,_("<%s> : Allocation of statistics"),_name.c_str());
+
+	statistics_allocation(_param_statistics);
+      }
+#endif
+
+#ifdef VHDL
+    if (usage_is_set(_usage,USE_VHDL))
+      {
+	// generate the vhdl
+	log_printf(INFO,Morpheo,FUNCTION,_("<%s> : Generate the vhdl"),_name.c_str());
+	
+	vhdl();
+      }
+#endif
+
+#ifdef SYSTEMC
+    if (usage_is_set(_usage,USE_SYSTEMC))
+      {
+	log_printf(INFO,Morpheo,FUNCTION,_("<%s> : Method - transition"),_name.c_str());
+
+	SC_METHOD (transition);
+	dont_initialize ();
+	sensitive << (*(in_CLOCK)).pos();
+	
+# ifdef SYSTEMCASS_SPECIFIC
+	// List dependency information
+# endif    
+	
+#endif
+      }
+    log_end(Morpheo,FUNCTION);
+  };
+    
+#undef  FUNCTION
+#define FUNCTION "Morpheo::~Morpheo"
+  Morpheo::~Morpheo (void)
+  {
+    log_begin(Morpheo,FUNCTION);
+
+#ifdef STATISTICS
+    if (usage_is_set(_usage,USE_STATISTICS))
+      {
+	statistics_deallocation();
+      }
+#endif
+
+    log_printf(INFO,Morpheo,FUNCTION,_("<%s> : Deallocation"),_name.c_str());
+    deallocation ();
+
+    delete _param_core;
+    delete _config;
+
+    log_end(Morpheo,FUNCTION);
+  };
+
+}; // end namespace morpheo
Index: /trunk/IPs/systemC/processor/Morpheo/TopLevel/src/Morpheo_allocation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/TopLevel/src/Morpheo_allocation.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/TopLevel/src/Morpheo_allocation.cpp	(revision 88)
@@ -0,0 +1,294 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "TopLevel/include/Morpheo.h"
+#include "Behavioural/include/Allocation.h"
+
+namespace morpheo {
+
+#undef  FUNCTION
+#define FUNCTION "Morpheo::allocation"
+  void Morpheo::allocation 
+  (
+#ifdef STATISTICS
+   morpheo::behavioural::Parameters_Statistics * param_statistics
+#else
+   void
+#endif
+   )
+  {
+    log_begin(Morpheo,FUNCTION);
+
+    _component = new behavioural::Component (_usage);
+
+    behavioural::Entity * entity = _component->set_entity (_name       
+					      ,"Morpheo"
+#ifdef POSITION
+					      ,COMBINATORY 
+#endif
+					      );
+
+    _interfaces = entity->set_interfaces();
+    
+    // ~~~~~[ Interface : "" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+    {
+      behavioural::Interface * interface = _interfaces->set_interface(""
+#ifdef POSITION
+							 ,IN
+							 ,SOUTH,
+							 "Generalist interface"
+#endif
+							 );
+      
+      in_CLOCK        = interface->set_signal_clk              ("clock" ,1, behavioural::CLOCK_VHDL_YES);
+      in_NRESET       = interface->set_signal_in  <Tcontrol_t> ("nreset",1, behavioural::RESET_VHDL_YES);
+    }
+
+
+    // ~~~~~[ Interface "icache_req" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+    {
+      ALLOC1_INTERFACE("icache_req",WEST,OUT,_("Request to instruction cache"),_nb_icache_port);
+
+      ALLOC1_VALACK_OUT(out_ICACHE_REQ_VAL         ,behavioural::VAL);
+      ALLOC1_VALACK_IN ( in_ICACHE_REQ_ACK         ,behavioural::ACK);
+      ALLOC1_SIGNAL_OUT(out_ICACHE_REQ_THREAD_ID   ,"thread_id",Ticache_context_t    ,_size_icache_thread_id);
+      ALLOC1_SIGNAL_OUT(out_ICACHE_REQ_PACKET_ID   ,"packet_id",Ticache_packet_t     ,_size_icache_packet_id);
+      ALLOC1_SIGNAL_OUT(out_ICACHE_REQ_ADDRESS     ,"address"  ,Ticache_address_t    ,_size_icache_address  );
+      ALLOC1_SIGNAL_OUT(out_ICACHE_REQ_TYPE        ,"type"     ,Ticache_type_t       ,_size_icache_type     );
+    }
+
+    // ~~~~~[ Interface "icache_rsp" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+    {
+      ALLOC1_INTERFACE("icache_rsp",WEST,IN ,_("Respons from instruction cache"),_nb_icache_port);
+      
+      ALLOC1_VALACK_IN ( in_ICACHE_RSP_VAL         ,behavioural::VAL);
+      ALLOC1_VALACK_OUT(out_ICACHE_RSP_ACK         ,behavioural::ACK);
+      ALLOC1_SIGNAL_IN ( in_ICACHE_RSP_THREAD_ID   ,"thread_id"  ,Ticache_context_t    ,_size_icache_thread_id);
+      ALLOC1_SIGNAL_IN ( in_ICACHE_RSP_PACKET_ID   ,"packet_id"  ,Ticache_packet_t     ,_size_icache_packet_id);
+      ALLOC1_SIGNAL_IN ( in_ICACHE_RSP_ERROR       ,"error"      ,Ticache_error_t      ,_size_icache_error);
+    }
+    {
+      ALLOC2_INTERFACE("icache_rsp",WEST,IN ,_("Respons from instruction cache"),_nb_icache_port,_icache_nb_instruction[it1]);
+      
+      _ALLOC2_SIGNAL_IN ( in_ICACHE_RSP_INSTRUCTION ,"instruction",Ticache_instruction_t,_size_icache_instruction,_nb_icache_port,_icache_nb_instruction[it1]);
+    }
+
+    // ~~~~~[ Interface "dcache_req" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+    {
+      ALLOC1_INTERFACE("dcache_req", OUT, NORTH, _("Request to data cache"),_nb_dcache_port);
+      
+      ALLOC1_VALACK_OUT(out_DCACHE_REQ_VAL         ,behavioural::VAL);
+      ALLOC1_VALACK_IN ( in_DCACHE_REQ_ACK         ,behavioural::ACK);
+      ALLOC1_SIGNAL_OUT(out_DCACHE_REQ_THREAD_ID   ,"thread_id",Tdcache_context_t    ,_size_dcache_thread_id);
+      ALLOC1_SIGNAL_OUT(out_DCACHE_REQ_PACKET_ID   ,"packet_id",Tdcache_packet_t     ,_size_dcache_packet_id);
+      ALLOC1_SIGNAL_OUT(out_DCACHE_REQ_ADDRESS     ,"address"  ,Tdcache_address_t    ,_size_dcache_address);
+      ALLOC1_SIGNAL_OUT(out_DCACHE_REQ_WDATA       ,"wdata"    ,Tdcache_data_t       ,_size_dcache_data);
+      ALLOC1_SIGNAL_OUT(out_DCACHE_REQ_TYPE        ,"type"     ,Tdcache_type_t       ,_size_dcache_type);
+    }
+									    
+    // ~~~~~[ Interface "dcache_rsp" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~  
+    {
+      ALLOC1_INTERFACE("dcache_rsp", IN , NORTH, _("Respons from data cache"),_nb_dcache_port);
+
+      ALLOC1_VALACK_IN ( in_DCACHE_RSP_VAL         ,behavioural::VAL);
+      ALLOC1_VALACK_OUT(out_DCACHE_RSP_ACK         ,behavioural::ACK);
+      ALLOC1_SIGNAL_IN ( in_DCACHE_RSP_THREAD_ID   ,"thread_id",Tdcache_context_t    ,_size_dcache_thread_id);
+      ALLOC1_SIGNAL_IN ( in_DCACHE_RSP_PACKET_ID   ,"packet_id",Tdcache_packet_t     ,_size_dcache_packet_id);
+      ALLOC1_SIGNAL_IN ( in_DCACHE_RSP_RDATA       ,"rdata"    ,Tdcache_data_t       ,_size_dcache_data);
+      ALLOC1_SIGNAL_IN ( in_DCACHE_RSP_ERROR       ,"error"    ,Tdcache_error_t      ,_size_dcache_error);
+    }
+
+    // ~~~~~[ Interface : "interrupt" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+    {
+      ALLOC1_INTERFACE("interrupt", IN , NORTH, _("Interruption line"),_nb_thread);
+
+      ALLOC1_SIGNAL_IN ( in_INTERRUPT_ENABLE      ,"enable",Tcontrol_t           ,1);
+    }
+
+    // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+    std::string name;
+
+    {
+      name = _name+"_core";
+      log_printf(INFO,Core,FUNCTION,_("Create   : %s"),name.c_str());
+      
+      _component_core = new morpheo::behavioural::core::Core
+        (name.c_str()
+#ifdef STATISTICS
+         ,param_statistics
+#endif
+         ,_param_core
+         ,_usage);
+      
+      _component->set_component (_component_core->_component
+#ifdef POSITION
+                                 , 50, 50, 10, 10
+#endif
+                                 );
+    }
+    
+    // ~~~~~[ Instanciation ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
+    std::string src,dest;
+
+    // ===================================================================
+    // =====[ core ]======================================================
+    // ===================================================================
+    {
+      src = _name+"_core";
+      log_printf(INFO,Core,FUNCTION,_("Instance : %s"),src.c_str());
+      
+      // ~~~~~[ Interface "" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+      {
+        dest = _name;
+#ifdef POSITION
+        _component->interface_map (src ,"",
+                                   dest,"");
+#endif
+        PORT_MAP(_component,src , "in_CLOCK" ,dest, "in_CLOCK");
+        PORT_MAP(_component,src , "in_NRESET",dest, "in_NRESET");
+      }
+
+      // ~~~~~[ Interface "icache_req" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+      for (uint32_t i=0; i<_nb_icache_port; ++i)
+        {
+          dest = _name;
+#ifdef POSITION
+          _component->interface_map (src ,"icache_req_"+toString(i),
+                                     dest,"icache_req_"+toString(i));
+#endif
+
+          PORT_MAP(_component,src ,"out_ICACHE_REQ_"+toString(i)+"_VAL"      ,
+                              dest,"out_ICACHE_REQ_"+toString(i)+"_VAL"      );
+          PORT_MAP(_component,src , "in_ICACHE_REQ_"+toString(i)+"_ACK"      ,
+                              dest, "in_ICACHE_REQ_"+toString(i)+"_ACK"      );
+          if (_have_port_icache_thread_id)
+          PORT_MAP(_component,src ,"out_ICACHE_REQ_"+toString(i)+"_THREAD_ID",
+                              dest,"out_ICACHE_REQ_"+toString(i)+"_THREAD_ID");
+          if (_have_port_icache_packet_id)
+          PORT_MAP(_component,src ,"out_ICACHE_REQ_"+toString(i)+"_PACKET_ID",
+                              dest,"out_ICACHE_REQ_"+toString(i)+"_PACKET_ID");
+          PORT_MAP(_component,src ,"out_ICACHE_REQ_"+toString(i)+"_ADDRESS"  ,
+                              dest,"out_ICACHE_REQ_"+toString(i)+"_ADDRESS"  );
+          PORT_MAP(_component,src ,"out_ICACHE_REQ_"+toString(i)+"_TYPE"     ,
+                              dest,"out_ICACHE_REQ_"+toString(i)+"_TYPE"     );
+        }
+
+      // ~~~~~[ Interface "icache_rsp" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~  
+      for (uint32_t i=0; i<_nb_icache_port; ++i)
+        {
+          dest = _name;
+#ifdef POSITION
+          _component->interface_map (src ,"icache_rsp_"+toString(i),
+                                     dest,"icache_rsp_"+toString(i));
+#endif
+
+          PORT_MAP(_component,src , "in_ICACHE_RSP_"+toString(i)+"_VAL"      ,
+                              dest, "in_ICACHE_RSP_"+toString(i)+"_VAL"      );
+          PORT_MAP(_component,src ,"out_ICACHE_RSP_"+toString(i)+"_ACK"      ,
+                              dest,"out_ICACHE_RSP_"+toString(i)+"_ACK"      );
+          if (_have_port_icache_thread_id)
+          PORT_MAP(_component,src , "in_ICACHE_RSP_"+toString(i)+"_THREAD_ID",
+                              dest, "in_ICACHE_RSP_"+toString(i)+"_THREAD_ID");
+          if (_have_port_icache_packet_id)
+          PORT_MAP(_component,src , "in_ICACHE_RSP_"+toString(i)+"_PACKET_ID",
+                              dest, "in_ICACHE_RSP_"+toString(i)+"_PACKET_ID");
+          PORT_MAP(_component,src , "in_ICACHE_RSP_"+toString(i)+"_ERROR"    ,
+                              dest, "in_ICACHE_RSP_"+toString(i)+"_ERROR"    );
+
+          for (uint32_t j=0; j<_icache_nb_instruction[i]; ++j)
+            {
+              dest = _name;
+#ifdef POSITION
+              _component->interface_map (src ,"icache_rsp_"+toString(i)+"_"+toString(j),
+                                         dest,"icache_rsp_"+toString(i)+"_"+toString(j));
+#endif
+              
+              PORT_MAP(_component,src , "in_ICACHE_RSP_"+toString(i)+"_"+toString(j)+"_INSTRUCTION",
+                                  dest, "in_ICACHE_RSP_"+toString(i)+"_"+toString(j)+"_INSTRUCTION");
+            }
+        }
+
+      // ~~~~~[ Interface "dcache_req" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+      for (uint32_t i=0; i<_nb_dcache_port; ++i)
+        {
+          dest = _name;
+#ifdef POSITION
+          _component->interface_map (src ,"dcache_req_"+toString(i),
+                                     dest,"dcache_req_"+toString(i));
+#endif
+
+          PORT_MAP(_component,src ,"out_DCACHE_REQ_"+toString(i)+"_VAL"      ,
+                              dest,"out_DCACHE_REQ_"+toString(i)+"_VAL"      );
+          PORT_MAP(_component,src , "in_DCACHE_REQ_"+toString(i)+"_ACK"      ,
+                              dest, "in_DCACHE_REQ_"+toString(i)+"_ACK"      );
+          if (_have_port_dcache_thread_id)
+          PORT_MAP(_component,src ,"out_DCACHE_REQ_"+toString(i)+"_THREAD_ID",
+                              dest,"out_DCACHE_REQ_"+toString(i)+"_THREAD_ID");
+          if (_have_port_dcache_packet_id)
+          PORT_MAP(_component,src ,"out_DCACHE_REQ_"+toString(i)+"_PACKET_ID",
+                              dest,"out_DCACHE_REQ_"+toString(i)+"_PACKET_ID");
+          PORT_MAP(_component,src ,"out_DCACHE_REQ_"+toString(i)+"_ADDRESS"  ,
+                              dest,"out_DCACHE_REQ_"+toString(i)+"_ADDRESS"  );
+          PORT_MAP(_component,src ,"out_DCACHE_REQ_"+toString(i)+"_WDATA"    ,
+                              dest,"out_DCACHE_REQ_"+toString(i)+"_WDATA"    );
+          PORT_MAP(_component,src ,"out_DCACHE_REQ_"+toString(i)+"_TYPE"     ,
+                              dest,"out_DCACHE_REQ_"+toString(i)+"_TYPE"     );
+        }
+
+      // ~~~~~[ Interface "dcache_rsp" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~  
+      for (uint32_t i=0; i<_nb_dcache_port; ++i)
+        {
+          dest = _name;
+#ifdef POSITION
+          _component->interface_map (src ,"dcache_rsp_"+toString(i),
+                                     dest,"dcache_rsp_"+toString(i));
+#endif
+
+          PORT_MAP(_component,src , "in_DCACHE_RSP_"+toString(i)+"_VAL"      ,
+                              dest, "in_DCACHE_RSP_"+toString(i)+"_VAL"      );
+          PORT_MAP(_component,src ,"out_DCACHE_RSP_"+toString(i)+"_ACK"      ,
+                              dest,"out_DCACHE_RSP_"+toString(i)+"_ACK"      );
+          if (_have_port_dcache_thread_id)
+          PORT_MAP(_component,src , "in_DCACHE_RSP_"+toString(i)+"_THREAD_ID",
+                              dest, "in_DCACHE_RSP_"+toString(i)+"_THREAD_ID");
+          if (_have_port_dcache_packet_id)
+          PORT_MAP(_component,src , "in_DCACHE_RSP_"+toString(i)+"_PACKET_ID",
+                              dest, "in_DCACHE_RSP_"+toString(i)+"_PACKET_ID");
+          PORT_MAP(_component,src , "in_DCACHE_RSP_"+toString(i)+"_RDATA"    ,
+                              dest, "in_DCACHE_RSP_"+toString(i)+"_RDATA"    );
+          PORT_MAP(_component,src , "in_DCACHE_RSP_"+toString(i)+"_ERROR"    ,
+                              dest, "in_DCACHE_RSP_"+toString(i)+"_ERROR"    );
+        }
+
+      // ~~~~~[ Interface "interrupt" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~  
+      for (uint32_t i=0; i<_nb_thread; ++i)
+        {
+          dest = _name;
+#ifdef POSITION
+          _component->interface_map (src ,"interrupt_"+toString(i),
+                                     dest,"interrupt_"+toString(i));
+#endif
+
+          PORT_MAP(_component,src , "in_INTERRUPT_"+toString(i)+"_ENABLE",
+                              dest, "in_INTERRUPT_"+toString(i)+"_ENABLE");
+        }
+    }
+
+
+    // ~~~~~[ Others ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 
+     if (DEBUG_Morpheo == true)
+       _component->test_map();
+
+#ifdef POSITION
+     if (usage_is_set(_usage,USE_POSITION))
+       _component->generate_file();
+#endif
+
+     log_end(Morpheo,FUNCTION);
+  };
+}; // end namespace morpheo
